
;  GNU C 2.7.2 [AL 1.1, MM 40] RISC NEWS-OS compiled by CC

;  Cc1 defaults:
;  -mmemcpy

;  Cc1 arguments (-G value = 0, Cpu = 3000, ISA = 1):
;  -quiet -dumpbase -O2 -Wall -o

gcc2_compiled.:
__gnu_compiled_c:
; APP
	
	.code				; RAMɔzu邽߁Aϐł.codeZNVƂ܂B
	.align	2
	.global	CYCLE
	.global	NOW
CYCLE:
	.word	0
NOW:
	.word	0

	
	.code
	.align	1
	.global	w65c02_read
w65c02_read:
	ld.w	%r9, %r0		; %r9 = addr>>7
	srl	%r9,0x7		; 	xsrl	%r9, 7
	jreq	_w65c02_read_tia	; 	xjreq	_w65c02_read_tia	; $0000-$007F: TIA
	cmp	%r9,0x5		; 	xcmp	%r9, 5			; /*0x280>>7=5*/
	jrlt	_w65c02_read_mem	; 	xjrlt	_w65c02_read_mem	; $0080-$00FF: RAM(PIA), $0180-$01FF: RAM̃~[
	jreq	_w65c02_read_pia	; 	xjreq	_w65c02_read_pia	; $0280-$02FF: PIA
	; /** FALLTHRU **/		; $0300-$F000: TIA,RAM,PIÃ~[, $F000-$FFFF: ROM
	;----------------------
_w65c02_read_mem:
	ext	mem@ah
	ext	mem@al
	ld.ub	%r1, [%r0]
	ret
	;----------------------
_w65c02_read_tia:
	ext	w65c02_leave@rm	; 	xcall.d	w65c02_leave
	call.d	w65c02_leave@rl
	ld.w	%r13, %r0		; %r13 <- %addr *delay*
	;
	ext	CYCLE+0x0@ah	; 	xld.w	%r9, [CYCLE]		; %r9   =        CYCLE
	ext	CYCLE+0x0@al
	ld.w	%r9,[%r8]
	ext	NOW+0x0@ah	; 	xld.w	%r12, [NOW]		; %r12  = NOW
	ext	NOW+0x0@al
	ld.w	%r12,[%r8]
	sub	%r9, %r15		; %r9   =        CYCLE - w65c02.cycle
	add	%r12, %r9		; %r12  = NOW + (CYCLE - w65c02.cycle)
	ext	NOW+0x0@ah	; 	xld.w	[NOW], %r12		; NOW   = NOW + (CYCLE - w65c02.cycle)
	ext	NOW+0x0@al
	ld.w	[%r8],%r12
	ext	CYCLE+0x0@ah	; 	xld.w	[CYCLE], %r15		; CYCLE =                w65c02.cycle
	ext	CYCLE+0x0@al
	ld.w	[%r8],%r15
	;
	ext	tia_read@rm	; 	xcall	tia_read		; return tia_read(NOW, addr)
	call	tia_read@rl
	ext	w65c02_enter@rm	; 	xjp.d	w65c02_enter
	jp.d	w65c02_enter@rl
	ld.w	%r1, %r10		; %r10 -> %data *delay*
	;----------------------
_w65c02_read_pia:
	ext	w65c02_leave@rm	; 	xcall.d	w65c02_leave
	call.d	w65c02_leave@rl
	ld.w	%r13, %r0		; %r13 <- %addr *delay*
	;
	ext	CYCLE+0x0@ah	; 	xld.w	%r9, [CYCLE]		; %r9   =        CYCLE
	ext	CYCLE+0x0@al
	ld.w	%r9,[%r8]
	ext	NOW+0x0@ah	; 	xld.w	%r12, [NOW]		; %r12  = NOW
	ext	NOW+0x0@al
	ld.w	%r12,[%r8]
	sub	%r9, %r15		; %r9   =        CYCLE - w65c02.cycle
	add	%r12, %r9		; %r12  = NOW + (CYCLE - w65c02.cycle)
	ext	NOW+0x0@ah	; 	xld.w	[NOW], %r12		; NOW   = NOW + (CYCLE - w65c02.cycle)
	ext	NOW+0x0@al
	ld.w	[%r8],%r12
	ext	CYCLE+0x0@ah	; 	xld.w	[CYCLE], %r15		; CYCLE =                w65c02.cycle
	ext	CYCLE+0x0@al
	ld.w	[%r8],%r15
	;
	ext	pia_read@rm	; 	xcall	pia_read		; return pia_read(NOW, addr)
	call	pia_read@rl
	ext	w65c02_enter@rm	; 	xjp.d	w65c02_enter
	jp.d	w65c02_enter@rl
	ld.w	%r1, %r10		; %r10 -> %data *delay*

	
	.code
	.align	1
	.global	w65c02_write
w65c02_write:
	ld.w	%r9, %r0		; %r9 = addr>>7
	srl	%r9,0x7		; 	xsrl	%r9, 7
	jreq	_w65c02_write_tia	; 	xjreq	_w65c02_write_tia	; $0000-$007F: TIA
	cmp	%r9,0x5		; 	xcmp	%r9, 5			; /*0x280>>7=5*/
	jrlt	_w65c02_write_mem	; 	xjrlt	_w65c02_write_mem	; $0080-$00FF: RAM(PIA), $0180-$01FF: RAM̃~[
	jreq	_w65c02_write_pia	; 	xjreq	_w65c02_write_pia	; $0280-$02FF: PIA
	ret				; $0300-$F000: TIA,RAM,PIÃ~[, $F000-$FFFF: ROM
	;----------------------
_w65c02_write_mem:
	ext	mem@ah
	ext	mem@al
	ld.b	[%r0], %r1
	ret
	;----------------------
_w65c02_write_tia:
	ext	w65c02_leave@rm	; 	xcall.d	w65c02_leave
	call.d	w65c02_leave@rl
	ld.w	%r13, %r0		; %r13 <- %addr *delay*
	;
	ext	CYCLE+0x0@ah	; 	xld.w	%r9, [CYCLE]		; %r9   =        CYCLE
	ext	CYCLE+0x0@al
	ld.w	%r9,[%r8]
	ext	NOW+0x0@ah	; 	xld.w	%r12, [NOW]		; %r12  = NOW
	ext	NOW+0x0@al
	ld.w	%r12,[%r8]
	sub	%r9, %r15		; %r9   =        CYCLE - w65c02.cycle
	add	%r12, %r9		; %r12  = NOW + (CYCLE - w65c02.cycle)
	ext	NOW+0x0@ah	; 	xld.w	[NOW], %r12		; NOW   = NOW + (CYCLE - w65c02.cycle)
	ext	NOW+0x0@al
	ld.w	[%r8],%r12
	ext	CYCLE+0x0@ah	; 	xld.w	[CYCLE], %r15		; CYCLE =                w65c02.cycle
	ext	CYCLE+0x0@al
	ld.w	[%r8],%r15
	;
	ext	tia_write@rm	; 	xcall.d	tia_write		; retval = tia_write(NOW, addr, data)
	call.d	tia_write@rl
	ld.w	%r14, %r1		; %r14 <- %data
	cmp	%r10,0x0	; 	xcmp	%r10, 0			; if(retval) { /* WSYNC̏ꍇ̂ */
	ext	w65c02_enter@rm	; 	xjreq	w65c02_enter
	jreq	w65c02_enter@rl
	sub	%r15, %r10		;   w65c02.cycle -= retval
	ext	w65c02+0xc@ah	; 	xld.w	[w65c02+12], %r15	;   w65c02.cyclẽItZbg=12Ɉˑ!!
	ext	w65c02+0xc@al
	ld.w	[%r8],%r15
	ext	w65c02_enter@rm	; 	xjp	w65c02_enter		; }
	jp	w65c02_enter@rl
	;----------------------
_w65c02_write_pia:
	ext	w65c02_leave@rm	; 	xcall.d	w65c02_leave
	call.d	w65c02_leave@rl
	ld.w	%r13, %r0		; %r13 <- %addr *delay*
	;
	ext	CYCLE+0x0@ah	; 	xld.w	%r9, [CYCLE]		; %r9   =        CYCLE
	ext	CYCLE+0x0@al
	ld.w	%r9,[%r8]
	ext	NOW+0x0@ah	; 	xld.w	%r12, [NOW]		; %r12  = NOW
	ext	NOW+0x0@al
	ld.w	%r12,[%r8]
	sub	%r9, %r15		; %r9   =        CYCLE - w65c02.cycle
	add	%r12, %r9		; %r12  = NOW + (CYCLE - w65c02.cycle)
	ext	NOW+0x0@ah	; 	xld.w	[NOW], %r12		; NOW   = NOW + (CYCLE - w65c02.cycle)
	ext	NOW+0x0@al
	ld.w	[%r8],%r12
	ext	CYCLE+0x0@ah	; 	xld.w	[CYCLE], %r15		; CYCLE =                w65c02.cycle
	ext	CYCLE+0x0@al
	ld.w	[%r8],%r15
	;
	ext	pia_write@rm	; 	xcall.d	pia_write		; pia_write(NOW, addr, data)
	call.d	pia_write@rl
	ld.w	%r14, %r1		; %r14 <- %data
	ext	w65c02_enter@rm	; 	xjp	w65c02_enter
	jp	w65c02_enter@rl

